/// <reference types="node" />
/// <reference types="webpack-env" />
import MessageType, { IMessageType } from './classes/MessageType';
import { ISerializationFormat } from './classes/SerializationFormat';
/**
 * TypeDecoratorReturn represents the type of the function returned by a @Type decorator
 */
export declare type TypeDecoratorReturn = (target: any) => void;
/**
 * TypeDecorator represents the type of the function returned by the 'megadata' default function
 */
export declare type TypeDecorator<I> = (id: I, format: ISerializationFormat) => TypeDecoratorReturn;
/**
 * 'megadata' type decorator generator
 */
export default function generateTypeDecorator<I extends number>(parentModule: NodeModule, require?: __WebpackModuleApi.RequireContext): (id: I, format: ISerializationFormat) => <M extends MessageType>(target: IMessageType<M>) => void;
